Index: res/res_pjsip_multihomed.c
===================================================================
--- res/res_pjsip_multihomed.c	(revision 430545)
+++ res/res_pjsip_multihomed.c	(working copy)
@@ -122,17 +122,18 @@
 		return PJ_SUCCESS;
 	}
 
+	transport = tdata->tp_info.transport;
+
 	/* If the transport it is going out on is different reflect it in the message */
 	if (tdata->tp_info.transport->key.type == PJSIP_TRANSPORT_UDP ||
 		tdata->tp_info.transport->key.type == PJSIP_TRANSPORT_UDP6) {
-		transport = multihomed_get_udp_transport(&prm.ret_addr, prm.ret_port);
+		if (pj_strcmp(&prm.ret_addr, &tdata->tp_info.transport->local_name.host)) {
+			/* Only change the transport if the underlying one is not going out on the interface */
+			transport = multihomed_get_udp_transport(&prm.ret_addr, prm.ret_port);
+		}
+		prm.ret_port = transport->local_name.port;
 	}
 
-	/* If no new transport use the one provided by the message */
-	if (!transport) {
-		transport = tdata->tp_info.transport;
-	}
-
 	/* If the message should not be rewritten then abort early */
 	if (!multihomed_rewrite_header(&prm.ret_addr, transport)) {
 		return PJ_SUCCESS;
